.586
.MODEL FLAT, STDCALL
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib

BIG_NUMBER      EQU 1fffffffh
;SLEEP_DO		EQU 1

doTrial MACRO 
	invoke GetPFreq
	invoke dwtoua, eax, addr szSpeed
	invoke StdOut, addr szSpeed
	invoke StdOut, addr szRet
ENDM

outhex MACRO val:REQ
	pushad
	invoke dw2hex, val, addr szSpeed
	invoke StdOut, addr szSpeed
	popad
endm

outqw MACRO
	outhex [eax+4]
	outhex [eax]
	pushad
	invoke StdOut, addr szRet
	popad
endm

GetPFreq		PROTO
dwtoua			PROTO :DWORD, :DWORD

.data

szSpeed		db 14 dup (0)
szRet		db 0Dh, 0Ah, 0

.code
start:

doTrial
doTrial
doTrial
doTrial
doTrial
doTrial
doTrial
doTrial
doTrial

invoke ExitProcess, 0

; ****************************************************************************
; Returns the processor frquency in Hz (Maximum is 4GHz... OK for now)
; If High Performance Clock is unavailable, it will return 0 (indicates error)
; ****************************************************************************

GetPFreq PROC
    LOCAL HPTimerFreq:QWORD

    LOCAL StartTime:QWORD
    LOCAL EndTime:QWORD

    LOCAL StartTSC:QWORD
    LOCAL EndTSC:QWORD

    LOCAL ProcFreq:DWORD
   
    ; ==============
    ; Get clock info
    ; ==============
   
    invoke QueryPerformanceFrequency, addr HPTimerFreq
   
    .if eax==FALSE
       xor eax, eax
       ret
    .endif

    ; ==============
    ; Get start vals
    ; ==============
   
    invoke QueryPerformanceCounter, addr StartTime
   
    rdtsc
    mov dword ptr StartTSC, eax
    mov dword ptr StartTSC + 4, edx
    
    ; ===============
    ; Waste some time
    ; ===============

	IFDEF SLEEP_DO
		invoke Sleep, 5000
	ELSE
	    xor ecx, ecx
@@:
	    inc ecx
	    cmp ecx, BIG_NUMBER
	    jne @B
	ENDIF
   
    ; ==============
    ; Get end values
    ; ==============
   
    invoke QueryPerformanceCounter, addr EndTime
   
    rdtsc
    mov dword ptr EndTSC, eax
    mov dword ptr EndTSC + 4, edx

    ; =============
    ; Do some maths
    ; =============
   
    fild EndTSC
    fild StartTSC
    fsubp ST(1), ST(0)
    fild EndTime
    fild StartTime
    fsubp ST(1), ST(0)
    fdivp ST(1), ST(0)
    fild HPTimerFreq
    fmulp ST(1), ST(0)
    fistp ProcFreq
   
    ; =========
    ; Exit proc
    ; =========

    mov eax, ProcFreq
    ret
GetPFreq ENDP

dwtoua proc dwValue:DWORD, lpBuffer:DWORD

    push ebx
    push esi
    push edi

    mov eax, dwValue
    mov edi, lpBuffer

    or eax,eax
    jnz pos
    
  zero:
    mov word ptr [edi],30h
    jmp dw2asc
    
  pos:      
;    mov ecx,429496730
	mov ecx, 10
    mov esi, edi

    .while (eax > 0)
    	xor edx, edx
    	div ecx
    	add edx, '0'
		mov [edi], dl
		inc edi
    .endw

    mov byte ptr [edi], 0       ; terminate the string

    ; We now have all the digits, but in reverse order.

    .while (esi < edi)
      dec edi
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      inc esi
    .endw

    dw2asc:

    pop edi
    pop esi
    pop ebx

    ret

dwtoua endp

end start
